*------------------------------------------------------------* ;
* Plot: DMDBClass Macro ;
*------------------------------------------------------------* ;
%macro DMDBClass;
    Churn2(DESC) Handset(ASC) tariff(ASC)
%mend DMDBClass;
*------------------------------------------------------------*;
* Plot: Create DMDB;
*------------------------------------------------------------*;
proc dmdb batch data=EMWS.Merge_TRAIN dmdbcat=WORK.Plot_DMDB
maxlevel = 23
nonorm
;
class %DMDBClass;
target
Churn2
;
run;
quit;
*------------------------------------------------------------*;
* Plot: Creating variable by class target charts;
*------------------------------------------------------------*;
goptions ftext="SWISS";
goptions nodisplay device=PNG;
axis1 width=2 offset=(1,1) label=(rotate=90 angle=270) minor=none;
axis2 width=2 minor=none;
pattern1 value=solid;
proc gchart
data=EMWS.Merge_TRAIN gout=WORK.PlotGRAPH;
*;
title "Handset by Churn2";
vbar Handset /
name = "Handset        x Churn2         " description = "Handset by Churn2"
FREQ
type=FREQ
subgroup=Churn2
noframe
missing
raxis=axis1 maxis=axis2;
run;
title "tariff by Churn2";
vbar tariff /
name = "tariff         x Churn2         " description = "tariff by Churn2"
FREQ
type=FREQ
subgroup=Churn2
noframe
missing
raxis=axis1 maxis=axis2;
run;
quit;
title;
goptions display;
*------------------------------------------------------------*;
* Plot: Copying graphs to node folder;
*------------------------------------------------------------*;
filename gsasfile "D:\EM\churn\Workspaces\EMWS\Plot\GRAPH\Handset by Churn2.gif";
goptions device= GIF display gaccess= gsasfile gsfmode= replace cback= white;
proc greplay igout=WORK.PLOTGRAPH nofs;
replay HANDSET;
quit;
goptions device=win;
filename gsasfile;
filename gsasfile "D:\EM\churn\Workspaces\EMWS\Plot\GRAPH\tariff by Churn2.gif";
goptions device= GIF display gaccess= gsasfile gsfmode= replace cback= white;
proc greplay igout=WORK.PLOTGRAPH nofs;
replay TARIFF;
quit;
goptions device=win;
filename gsasfile;
