*************************************;
*** begin scoring code for regression;
*************************************;

length _WARN_ $4;
label _WARN_ = 'Warnings' ;

length I_Churn2 $ 1;
label I_Churn2 = 'Into: Churn2' ;
*** Target Values;
array REGDRF [2] $1 _temporary_ ('1' '0' );
label U_Churn2 = 'Unnormalized Into: Churn2' ;
format U_Churn2 BEST1.;
*** Unnormalized target values;
ARRAY REGDRU[2]  _TEMPORARY_ (1 0);

*** Generate dummy variables for Churn2 ;
drop _Y ;
label F_Churn2 = 'From: Churn2' ;
length F_Churn2 $ 1;
F_Churn2 = put( Churn2 , BEST1. );
%DMNORMIP( F_Churn2 )
if missing( Churn2 ) then do;
   _Y = .;
end;
else do;
   if F_Churn2 = '0'  then do;
      _Y = 1;
   end;
   else if F_Churn2 = '1'  then do;
      _Y = 0;
   end;
   else do;
      _Y = .;
   end;
end;

drop _DM_BAD;
_DM_BAD=0;

*** Generate dummy variables for GRP_IMP_Age ;
drop _1_0 _1_1 _1_2 ;
if missing( GRP_IMP_Age ) then do;
   _1_0 = .;
   _1_1 = .;
   _1_2 = .;
   substr(_warn_,1,1) = 'M';
   _DM_BAD = 1;
end;
else do;
   length _dm12 $ 12; drop _dm12 ;
   _dm12 = put( GRP_IMP_Age , BEST12. );
   %DMNORMIP( _dm12 )
   if _dm12 = '5'  then do;
      _1_0 = -1;
      _1_1 = -1;
      _1_2 = -1;
   end;
   else if _dm12 = '4'  then do;
      _1_0 = 0;
      _1_1 = 0;
      _1_2 = 1;
   end;
   else if _dm12 = '3'  then do;
      _1_0 = 0;
      _1_1 = 1;
      _1_2 = 0;
   end;
   else if _dm12 = '2'  then do;
      _1_0 = 1;
      _1_1 = 0;
      _1_2 = 0;
   end;
   else do;
      _1_0 = .;
      _1_1 = .;
      _1_2 = .;
      substr(_warn_,2,1) = 'U';
      _DM_BAD = 1;
   end;
end;

*** Generate dummy variables for GRP_OffPeak_calls_ratio ;
drop _2_0 _2_1 _2_2 ;
if missing( GRP_OffPeak_calls_ratio ) then do;
   _2_0 = .;
   _2_1 = .;
   _2_2 = .;
   substr(_warn_,1,1) = 'M';
   _DM_BAD = 1;
end;
else do;
   length _dm12 $ 12; drop _dm12 ;
   _dm12 = put( GRP_OffPeak_calls_ratio , BEST12. );
   %DMNORMIP( _dm12 )
   if _dm12 = '5'  then do;
      _2_0 = -1;
      _2_1 = -1;
      _2_2 = -1;
   end;
   else if _dm12 = '2'  then do;
      _2_0 = 1;
      _2_1 = 0;
      _2_2 = 0;
   end;
   else if _dm12 = '3'  then do;
      _2_0 = 0;
      _2_1 = 1;
      _2_2 = 0;
   end;
   else if _dm12 = '4'  then do;
      _2_0 = 0;
      _2_1 = 0;
      _2_2 = 1;
   end;
   else do;
      _2_0 = .;
      _2_1 = .;
      _2_2 = .;
      substr(_warn_,2,1) = 'U';
      _DM_BAD = 1;
   end;
end;

*** Generate dummy variables for GRP_OffPeak_mins_ratio ;
drop _4_0 _4_1 _4_2 ;
if missing( GRP_OffPeak_mins_ratio ) then do;
   _4_0 = .;
   _4_1 = .;
   _4_2 = .;
   substr(_warn_,1,1) = 'M';
   _DM_BAD = 1;
end;
else do;
   length _dm12 $ 12; drop _dm12 ;
   _dm12 = put( GRP_OffPeak_mins_ratio , BEST12. );
   %DMNORMIP( _dm12 )
   if _dm12 = '3'  then do;
      _4_0 = 0;
      _4_1 = 1;
      _4_2 = 0;
   end;
   else if _dm12 = '4'  then do;
      _4_0 = 0;
      _4_1 = 0;
      _4_2 = 1;
   end;
   else if _dm12 = '5'  then do;
      _4_0 = -1;
      _4_1 = -1;
      _4_2 = -1;
   end;
   else if _dm12 = '2'  then do;
      _4_0 = 1;
      _4_1 = 0;
      _4_2 = 0;
   end;
   else do;
      _4_0 = .;
      _4_1 = .;
      _4_2 = .;
      substr(_warn_,2,1) = 'U';
      _DM_BAD = 1;
   end;
end;

*** Generate dummy variables for GRP_Peak_calls_1234 ;
drop _6_0 _6_1 _6_2 ;
if missing( GRP_Peak_calls_1234 ) then do;
   _6_0 = .;
   _6_1 = .;
   _6_2 = .;
   substr(_warn_,1,1) = 'M';
   _DM_BAD = 1;
end;
else do;
   length _dm12 $ 12; drop _dm12 ;
   _dm12 = put( GRP_Peak_calls_1234 , BEST12. );
   %DMNORMIP( _dm12 )
   if _dm12 = '4'  then do;
      _6_0 = 0;
      _6_1 = 0;
      _6_2 = 1;
   end;
   else if _dm12 = '5'  then do;
      _6_0 = -1;
      _6_1 = -1;
      _6_2 = -1;
   end;
   else if _dm12 = '3'  then do;
      _6_0 = 0;
      _6_1 = 1;
      _6_2 = 0;
   end;
   else if _dm12 = '2'  then do;
      _6_0 = 1;
      _6_1 = 0;
      _6_2 = 0;
   end;
   else do;
      _6_0 = .;
      _6_1 = .;
      _6_2 = .;
      substr(_warn_,2,1) = 'U';
      _DM_BAD = 1;
   end;
end;

*** Generate dummy variables for GRP_Peak_calls_56 ;
drop _7_0 _7_1 _7_2 ;
if missing( GRP_Peak_calls_56 ) then do;
   _7_0 = .;
   _7_1 = .;
   _7_2 = .;
   substr(_warn_,1,1) = 'M';
   _DM_BAD = 1;
end;
else do;
   length _dm12 $ 12; drop _dm12 ;
   _dm12 = put( GRP_Peak_calls_56 , BEST12. );
   %DMNORMIP( _dm12 )
   if _dm12 = '3'  then do;
      _7_0 = 0;
      _7_1 = 1;
      _7_2 = 0;
   end;
   else if _dm12 = '4'  then do;
      _7_0 = 0;
      _7_1 = 0;
      _7_2 = 1;
   end;
   else if _dm12 = '5'  then do;
      _7_0 = -1;
      _7_1 = -1;
      _7_2 = -1;
   end;
   else if _dm12 = '2'  then do;
      _7_0 = 1;
      _7_1 = 0;
      _7_2 = 0;
   end;
   else do;
      _7_0 = .;
      _7_1 = .;
      _7_2 = .;
      substr(_warn_,2,1) = 'U';
      _DM_BAD = 1;
   end;
end;

*** Generate dummy variables for GRP_Peak_mins_ratio ;
drop _8_0 _8_1 _8_2 ;
if missing( GRP_Peak_mins_ratio ) then do;
   _8_0 = .;
   _8_1 = .;
   _8_2 = .;
   substr(_warn_,1,1) = 'M';
   _DM_BAD = 1;
end;
else do;
   length _dm12 $ 12; drop _dm12 ;
   _dm12 = put( GRP_Peak_mins_ratio , BEST12. );
   %DMNORMIP( _dm12 )
   if _dm12 = '5'  then do;
      _8_0 = -1;
      _8_1 = -1;
      _8_2 = -1;
   end;
   else if _dm12 = '3'  then do;
      _8_0 = 0;
      _8_1 = 1;
      _8_2 = 0;
   end;
   else if _dm12 = '2'  then do;
      _8_0 = 1;
      _8_1 = 0;
      _8_2 = 0;
   end;
   else if _dm12 = '4'  then do;
      _8_0 = 0;
      _8_1 = 0;
      _8_2 = 1;
   end;
   else do;
      _8_0 = .;
      _8_1 = .;
      _8_2 = .;
      substr(_warn_,2,1) = 'U';
      _DM_BAD = 1;
   end;
end;

*** Generate dummy variables for GRP_mon_dif ;
drop _10_0 _10_1 _10_2 ;
if missing( GRP_mon_dif ) then do;
   _10_0 = .;
   _10_1 = .;
   _10_2 = .;
   substr(_warn_,1,1) = 'M';
   _DM_BAD = 1;
end;
else do;
   length _dm12 $ 12; drop _dm12 ;
   _dm12 = put( GRP_mon_dif , BEST12. );
   %DMNORMIP( _dm12 )
   if _dm12 = '5'  then do;
      _10_0 = -1;
      _10_1 = -1;
      _10_2 = -1;
   end;
   else if _dm12 = '3'  then do;
      _10_0 = 0;
      _10_1 = 1;
      _10_2 = 0;
   end;
   else if _dm12 = '4'  then do;
      _10_0 = 0;
      _10_1 = 0;
      _10_2 = 1;
   end;
   else if _dm12 = '2'  then do;
      _10_0 = 1;
      _10_1 = 0;
      _10_2 = 0;
   end;
   else do;
      _10_0 = .;
      _10_1 = .;
      _10_2 = .;
      substr(_warn_,2,1) = 'U';
      _DM_BAD = 1;
   end;
end;

*** Generate dummy variables for GRP_tariff ;
drop _11_0 _11_1 _11_2 _11_3 ;
*** encoding is sparse, initialize to zero;
_11_0 = 0;
_11_1 = 0;
_11_2 = 0;
_11_3 = 0;
if missing( GRP_tariff ) then do;
   _11_0 = .;
   _11_1 = .;
   _11_2 = .;
   _11_3 = .;
   substr(_warn_,1,1) = 'M';
   _DM_BAD = 1;
end;
else do;
   length _dm12 $ 12; drop _dm12 ;
   _dm12 = put( GRP_tariff , BEST12. );
   %DMNORMIP( _dm12 )
   _dm_find = 0; drop _dm_find;
   if _dm12 <= '4'  then do;
      if _dm12 <= '3'  then do;
         if _dm12 = '2'  then do;
            _11_0 = 1;
            _dm_find = 1;
         end;
         else do;
            if _dm12 = '3'  then do;
               _11_1 = 1;
               _dm_find = 1;
            end;
         end;
      end;
      else do;
         if _dm12 = '4'  then do;
            _11_2 = 1;
            _dm_find = 1;
         end;
      end;
   end;
   else do;
      if _dm12 = '5'  then do;
         _11_3 = 1;
         _dm_find = 1;
      end;
      else do;
         if _dm12 = '6'  then do;
            _11_0 = -1;
            _11_1 = -1;
            _11_2 = -1;
            _11_3 = -1;
            _dm_find = 1;
         end;
      end;
   end;
   if not _dm_find then do;
      _11_0 = .;
      _11_1 = .;
      _11_2 = .;
      _11_3 = .;
      substr(_warn_,2,1) = 'U';
      _DM_BAD = 1;
   end;
end;

*** If missing inputs, use averages;
if _DM_BAD > 0 then do;
   _P0 = 0.0586894254;
   _P1 = 0.9413105746;
   goto REGDR1;
end;

*** Compute Linear Predictor;
drop _TEMP;
drop _LP0;
_LP0 = 0;

***  Effect: GRP_IMP_Age ;
_TEMP = 1;
_LP0 = _LP0 + (    0.69830426411196) * _TEMP * _1_0;
_LP0 = _LP0 + (   -0.08106789047937) * _TEMP * _1_1;
_LP0 = _LP0 + (   -0.53204396790518) * _TEMP * _1_2;

***  Effect: GRP_OffPeak_calls_ratio ;
_TEMP = 1;
_LP0 = _LP0 + (    0.23139470538011) * _TEMP * _2_0;
_LP0 = _LP0 + (    0.17507240183427) * _TEMP * _2_1;
_LP0 = _LP0 + (   -0.09234979420177) * _TEMP * _2_2;

***  Effect: GRP_OffPeak_mins_ratio ;
_TEMP = 1;
_LP0 = _LP0 + (    0.21606904694734) * _TEMP * _4_0;
_LP0 = _LP0 + (   -0.16912920629492) * _TEMP * _4_1;
_LP0 = _LP0 + (   -0.41929885075073) * _TEMP * _4_2;

***  Effect: GRP_Peak_calls_1234 ;
_TEMP = 1;
_LP0 = _LP0 + (    0.43197178694663) * _TEMP * _6_0;
_LP0 = _LP0 + (    0.18166110900745) * _TEMP * _6_1;
_LP0 = _LP0 + (   -0.03929226424369) * _TEMP * _6_2;

***  Effect: GRP_Peak_calls_56 ;
_TEMP = 1;
_LP0 = _LP0 + (    0.08573939140872) * _TEMP * _7_0;
_LP0 = _LP0 + (    0.18984247641494) * _TEMP * _7_1;
_LP0 = _LP0 + (    0.06492535975522) * _TEMP * _7_2;

***  Effect: GRP_Peak_mins_ratio ;
_TEMP = 1;
_LP0 = _LP0 + (    0.20441011140502) * _TEMP * _8_0;
_LP0 = _LP0 + (    0.10631819862474) * _TEMP * _8_1;
_LP0 = _LP0 + (    0.33836183607967) * _TEMP * _8_2;

***  Effect: GRP_mon_dif ;
_TEMP = 1;
_LP0 = _LP0 + (    0.64639070261728) * _TEMP * _10_0;
_LP0 = _LP0 + (    0.16877942353213) * _TEMP * _10_1;
_LP0 = _LP0 + (   -0.28893340808593) * _TEMP * _10_2;

***  Effect: GRP_tariff ;
_TEMP = 1;
_LP0 = _LP0 + (   -0.11481831904295) * _TEMP * _11_0;
_LP0 = _LP0 + (    0.22861504888289) * _TEMP * _11_1;
_LP0 = _LP0 + (    0.16245836826518) * _TEMP * _11_2;
_LP0 = _LP0 + (   -0.15819706757075) * _TEMP * _11_3;

*** Naive Posterior Probabilities;
drop _MAXP _IY _P0 _P1;
_TEMP =    -3.11841524244499 + _LP0;
if (_TEMP < 0) then do;
   _TEMP = exp(_TEMP);
   _P0 = _TEMP / (1 + _TEMP);
end;
else _P0 = 1 / (1 + exp(-_TEMP));
_P1 = 1.0 - _P0;

REGDR1:

*** Residuals;
if (_Y = .) then do;
   R_Churn21 = .;
   R_Churn20 = .;
end;
else do;
    label R_Churn21 = 'Residual: Churn2=1' ;
    label R_Churn20 = 'Residual: Churn2=0' ;
   R_Churn21 = - _P0;
   R_Churn20 = - _P1;
   select( _Y );
      when (0)  R_Churn21 = R_Churn21 + 1;
      when (1)  R_Churn20 = R_Churn20 + 1;
   end;
end;

*** Posterior Probabilities and Predicted Level;
label P_Churn21 = 'Predicted: Churn2=1' ;
label P_Churn20 = 'Predicted: Churn2=0' ;
P_Churn21 = _P0;
_MAXP = _P0;
_IY = 1;
P_Churn20 = _P1;
if (_P1 - _MAXP > 1e-8) then do;
   _MAXP = _P1;
   _IY = 2;
end;
I_Churn2 = REGDRF[_IY];
U_Churn2 = REGDRU[_IY];

*************************************;
***** end scoring code for regression;
*************************************;
