*------------------------------------------------------------*;
* Reg: Create decision matrix;
*------------------------------------------------------------*;
data WORK.Churn2;
  length   Churn2                           $  32
           COUNT                                8
           DATAPRIOR                            8
           TRAINPRIOR                           8
           DECPRIOR                             8
           DECISION1                            8
           DECISION2                            8
           ;

  label    COUNT="Level Counts"
           DATAPRIOR="Data Proportions"
           TRAINPRIOR="Training Proportions"
           DECPRIOR="Decision Priors"
           DECISION1="1"
           DECISION2="0"
           ;
Churn2="1"; COUNT=1004; DATAPRIOR=0.05868942538142; TRAINPRIOR=5.86894253814228; DECPRIOR=.; DECISION1=1; DECISION2=0;
output;
Churn2="0"; COUNT=16103; DATAPRIOR=0.94131057461857; TRAINPRIOR=94.1310574618577; DECPRIOR=.; DECISION1=0; DECISION2=1;
output;
;
run;
proc datasets lib=work nolist;
modify Churn2(type=PROFIT label=Churn2);
label DECISION1= "1";
label DECISION2= "0";
run;
quit;
*------------------------------------------------------------* ;
* Reg: DMDBClass Macro ;
*------------------------------------------------------------* ;
%macro DMDBClass;
    Churn2(DESC) GRP_IMP_Age(ASC) GRP_OffPeak_calls_ratio(ASC)
   GRP_OffPeak_calls_ratio_out(ASC) GRP_OffPeak_mins_ratio(ASC)
   GRP_OffPeak_mins_ratio_out(ASC) GRP_Peak_calls_1234(ASC) GRP_Peak_calls_56(ASC)
   GRP_Peak_mins_ratio(ASC) GRP_Peak_mins_ratio_out(ASC) GRP_mon_dif(ASC)
   GRP_tariff(ASC)
%mend DMDBClass;
*------------------------------------------------------------* ;
* Reg: DMDBVar Macro ;
*------------------------------------------------------------* ;
%macro DMDBVar;

%mend DMDBVar;
*------------------------------------------------------------*;
* Reg: Create DMDB;
*------------------------------------------------------------*;
proc dmdb batch data=EMWS.Drop2_TRAIN dmdbcat=WORK.Reg_DMDB
maxlevel = 513
;
class %DMDBClass;
target
Churn2
;
run;
quit;
*------------------------------------------------------------*;
* Reg: Run DMREG procedure;
*------------------------------------------------------------*;
proc dmreg data=EMWS.Drop2_TRAIN dmdbcat=WORK.Reg_DMDB
validata = EMWS.Drop2_VALIDATE
outest = EMWS.Reg_EMESTIMATE
outterms = EMWS.Reg_OUTTERMS
outmap= EMWS.Reg_MAPDS namelen=200
;
class
Churn2
GRP_IMP_Age
GRP_OffPeak_calls_ratio
GRP_OffPeak_calls_ratio_out
GRP_OffPeak_mins_ratio
GRP_OffPeak_mins_ratio_out
GRP_Peak_calls_1234
GRP_Peak_calls_56
GRP_Peak_mins_ratio
GRP_Peak_mins_ratio_out
GRP_mon_dif
GRP_tariff
;
model Churn2 =
GRP_IMP_Age
GRP_OffPeak_calls_ratio
GRP_OffPeak_calls_ratio_out
GRP_OffPeak_mins_ratio
GRP_OffPeak_mins_ratio_out
GRP_Peak_calls_1234
GRP_Peak_calls_56
GRP_Peak_mins_ratio
GRP_Peak_mins_ratio_out
GRP_mon_dif
GRP_tariff
/error=binomial link=LOGIT
coding=DEVIATION
nodesignprint
;
;
score data=EMWS.Drop2_TEST
out=_null_
outfit=EMWS.Reg_FITTEST
role = TEST
;
code file="D:\EM\churn\Workspaces\EMWS\Reg\EMPUBLISHSCORE.sas"
group=Reg
;
code file="D:\EM\churn\Workspaces\EMWS\Reg\EMFLOWSCORE.sas"
group=Reg
residual
;
run;
quit;
