*------------------------------------------------------------*;
* EM SCORE CODE;
* VERSION: 6.12;
* GENERATED BY: sastrust;
* CREATED: 22NOV2010:14:10:58;
*------------------------------------------------------------*;
*------------------------------------------------------------*;
* TOOL: Merge Class;
* TYPE: UTILITY;
* NODE: Merge;
*------------------------------------------------------------*;
*------------------------------------------------------------*;
* Merge: Score Code of path 1;
*------------------------------------------------------------*;
data &em_score_output;
set &em_score_output;
*------------------------------------------------------------*;
* TOOL: Input Data Source;
* TYPE: SAMPLE;
* NODE: Ids3;
*------------------------------------------------------------*;
data em_Merge_path1;
set &em_score_output;
run;
*------------------------------------------------------------*;
* Merge: Score Code of path 2;
*------------------------------------------------------------*;
data &em_score_output;
set &em_score_output;
*------------------------------------------------------------*;
* TOOL: Input Data Source;
* TYPE: SAMPLE;
* NODE: Ids;
*------------------------------------------------------------*;
data em_Merge_path2;
set &em_score_output;
run;
*------------------------------------------------------------*;
* Merge: Merging 2 Paths;
*------------------------------------------------------------*;
data &em_score_output;
merge
em_Merge_path1
em_Merge_path2
;
run;
proc datasets lib=WORK nolist;
delete
em_Merge_path1
em_Merge_path2
;
run;
quit;
data &em_score_output;
set &em_score_output;
*------------------------------------------------------------*;
* TOOL: Transform;
* TYPE: MODIFY;
* NODE: Trans;
*------------------------------------------------------------*;
*------------------------------------------------------------*;
* Formula Code;
*------------------------------------------------------------*;
length handset_cat  $18 ;
handset_cat =SCAN(Handset,1) ;
*------------------------------------------------------------*;
* TOOL: Drop Node;
* TYPE: MODIFY;
* NODE: Drop;
*------------------------------------------------------------*;
*------------------------------------------------------------*;
* TOOL: Partition Class;
* TYPE: SAMPLE;
* NODE: Part;
*------------------------------------------------------------*;
*------------------------------------------------------------*;
* TOOL: Imputation;
* TYPE: MODIFY;
* NODE: Impt;
*------------------------------------------------------------*;
*;
*DISTRIBUTION-BASED IMPUTATION: Interval VARIABLES;
*;
*;
* IMPUTE VARIABLE: Age;
*;
format IMP_Age BEST2.0;
label IMP_Age = 'Imputed Age';
IMP_Age = Age;
IF Age eq . THEN DO;
_random_ = DMRAN(12345);
if _random_ <= 0.01 then IMP_Age = 12;
else if _random_ <= 0.1 then IMP_Age = 12;
else if _random_ <= 0.10 then IMP_Age = 15;
else if _random_ <= 0.20 then IMP_Age = 19;
else if _random_ <= 0.25 then IMP_Age = 20;
else if _random_ <= 0.30 then IMP_Age = 22;
else if _random_ <= 0.40 then IMP_Age = 25;
else if _random_ <= 0.50 then IMP_Age = 28;
else if _random_ <= 0.60 then IMP_Age = 31;
else if _random_ <= 0.75 then IMP_Age = 38;
else if _random_ <= 0.80 then IMP_Age = 41;
else if _random_ <= 0.90 then IMP_Age = 49;
else if _random_ <= 0.99 then IMP_Age = 66;
else IMP_Age = 82;
END;
drop _random_;
*------------------------------------------------------------*;
* TOOL: Extension Class;
* TYPE: MODIFY;
* NODE: BINNING;
*------------------------------------------------------------*;
length _UFormat $200;
drop _UFormat;
_UFormat='';

*------------------------------------------------------------*;
* Variable: IMP_Age;
*------------------------------------------------------------*;
LABEL GRP_IMP_Age = 'Grouped: Imputed Age';

if MISSING(IMP_Age) then do;
GRP_IMP_Age = 1;
end;
else if NOT MISSING(IMP_Age) then do;
if IMP_Age < 20 then do;
GRP_IMP_Age = 2;
end;
else
if 20 <= IMP_Age AND IMP_Age < 28 then do;
GRP_IMP_Age = 3;
end;
else
if 28 <= IMP_Age AND IMP_Age < 38 then do;
GRP_IMP_Age = 4;
end;
else
if 38 <= IMP_Age then do;
GRP_IMP_Age = 5;
end;
end;

*------------------------------------------------------------*;
* Variable: OffPeak_calls_ratio;
*------------------------------------------------------------*;
LABEL GRP_OffPeak_calls_ratio = 'Grouped: OffPeak_calls_ratio';

if MISSING(OffPeak_calls_ratio) then do;
GRP_OffPeak_calls_ratio = 1;
end;
else if NOT MISSING(OffPeak_calls_ratio) then do;
if OffPeak_calls_ratio < 0.98 then do;
GRP_OffPeak_calls_ratio = 2;
end;
else
if 0.98 <= OffPeak_calls_ratio AND OffPeak_calls_ratio < 1.14 then do;
GRP_OffPeak_calls_ratio = 3;
end;
else
if 1.14 <= OffPeak_calls_ratio AND OffPeak_calls_ratio < 1.33 then do;
GRP_OffPeak_calls_ratio = 4;
end;
else
if 1.33 <= OffPeak_calls_ratio then do;
GRP_OffPeak_calls_ratio = 5;
end;
end;

*------------------------------------------------------------*;
* Variable: OffPeak_calls_ratio_out;
*------------------------------------------------------------*;
LABEL GRP_OffPeak_calls_ratio_out = 'Grouped: OffPeak_calls_ratio_out';

if MISSING(OffPeak_calls_ratio_out) then do;
GRP_OffPeak_calls_ratio_out = 1;
end;
else if NOT MISSING(OffPeak_calls_ratio_out) then do;
if OffPeak_calls_ratio_out < 0.98 then do;
GRP_OffPeak_calls_ratio_out = 2;
end;
else
if 0.98 <= OffPeak_calls_ratio_out AND OffPeak_calls_ratio_out < 1.14 then do;
GRP_OffPeak_calls_ratio_out = 3;
end;
else
if 1.14 <= OffPeak_calls_ratio_out AND OffPeak_calls_ratio_out < 1.33 then do;
GRP_OffPeak_calls_ratio_out = 4;
end;
else
if 1.33 <= OffPeak_calls_ratio_out then do;
GRP_OffPeak_calls_ratio_out = 5;
end;
end;

*------------------------------------------------------------*;
* Variable: OffPeak_mins_ratio;
*------------------------------------------------------------*;
LABEL GRP_OffPeak_mins_ratio = 'Grouped: OffPeak_mins_ratio';

if MISSING(OffPeak_mins_ratio) then do;
GRP_OffPeak_mins_ratio = 1;
end;
else if NOT MISSING(OffPeak_mins_ratio) then do;
if OffPeak_mins_ratio < 0.91 then do;
GRP_OffPeak_mins_ratio = 2;
end;
else
if 0.91 <= OffPeak_mins_ratio AND OffPeak_mins_ratio < 1.06 then do;
GRP_OffPeak_mins_ratio = 3;
end;
else
if 1.06 <= OffPeak_mins_ratio AND OffPeak_mins_ratio < 1.22 then do;
GRP_OffPeak_mins_ratio = 4;
end;
else
if 1.22 <= OffPeak_mins_ratio then do;
GRP_OffPeak_mins_ratio = 5;
end;
end;

*------------------------------------------------------------*;
* Variable: OffPeak_mins_ratio_out;
*------------------------------------------------------------*;
LABEL GRP_OffPeak_mins_ratio_out = 'Grouped: OffPeak_mins_ratio_out';

if MISSING(OffPeak_mins_ratio_out) then do;
GRP_OffPeak_mins_ratio_out = 1;
end;
else if NOT MISSING(OffPeak_mins_ratio_out) then do;
if OffPeak_mins_ratio_out < 0.91 then do;
GRP_OffPeak_mins_ratio_out = 2;
end;
else
if 0.91 <= OffPeak_mins_ratio_out AND OffPeak_mins_ratio_out < 1.06 then do;
GRP_OffPeak_mins_ratio_out = 3;
end;
else
if 1.06 <= OffPeak_mins_ratio_out AND OffPeak_mins_ratio_out < 1.22 then do;
GRP_OffPeak_mins_ratio_out = 4;
end;
else
if 1.22 <= OffPeak_mins_ratio_out then do;
GRP_OffPeak_mins_ratio_out = 5;
end;
end;

*------------------------------------------------------------*;
* Variable: Peak_calls_1234;
*------------------------------------------------------------*;
LABEL GRP_Peak_calls_1234 = 'Grouped: Peak_calls_1234';

if MISSING(Peak_calls_1234) then do;
GRP_Peak_calls_1234 = 1;
end;
else if NOT MISSING(Peak_calls_1234) then do;
if Peak_calls_1234 < 34 then do;
GRP_Peak_calls_1234 = 2;
end;
else
if 34 <= Peak_calls_1234 AND Peak_calls_1234 < 99 then do;
GRP_Peak_calls_1234 = 3;
end;
else
if 99 <= Peak_calls_1234 AND Peak_calls_1234 < 219 then do;
GRP_Peak_calls_1234 = 4;
end;
else
if 219 <= Peak_calls_1234 then do;
GRP_Peak_calls_1234 = 5;
end;
end;

*------------------------------------------------------------*;
* Variable: Peak_calls_56;
*------------------------------------------------------------*;
LABEL GRP_Peak_calls_56 = 'Grouped: Peak_calls_56';

if MISSING(Peak_calls_56) then do;
GRP_Peak_calls_56 = 1;
end;
else if NOT MISSING(Peak_calls_56) then do;
if Peak_calls_56 < 19 then do;
GRP_Peak_calls_56 = 2;
end;
else
if 19 <= Peak_calls_56 AND Peak_calls_56 < 54 then do;
GRP_Peak_calls_56 = 3;
end;
else
if 54 <= Peak_calls_56 AND Peak_calls_56 < 119 then do;
GRP_Peak_calls_56 = 4;
end;
else
if 119 <= Peak_calls_56 then do;
GRP_Peak_calls_56 = 5;
end;
end;

*------------------------------------------------------------*;
* Variable: Peak_mins_ratio;
*------------------------------------------------------------*;
LABEL GRP_Peak_mins_ratio = 'Grouped: Peak_mins_ratio';

if MISSING(Peak_mins_ratio) then do;
GRP_Peak_mins_ratio = 1;
end;
else if NOT MISSING(Peak_mins_ratio) then do;
if Peak_mins_ratio < 0.93 then do;
GRP_Peak_mins_ratio = 2;
end;
else
if 0.93 <= Peak_mins_ratio AND Peak_mins_ratio < 1.07 then do;
GRP_Peak_mins_ratio = 3;
end;
else
if 1.07 <= Peak_mins_ratio AND Peak_mins_ratio < 1.22 then do;
GRP_Peak_mins_ratio = 4;
end;
else
if 1.22 <= Peak_mins_ratio then do;
GRP_Peak_mins_ratio = 5;
end;
end;

*------------------------------------------------------------*;
* Variable: Peak_mins_ratio_out;
*------------------------------------------------------------*;
LABEL GRP_Peak_mins_ratio_out = 'Grouped: Peak_mins_ratio_out';

if MISSING(Peak_mins_ratio_out) then do;
GRP_Peak_mins_ratio_out = 1;
end;
else if NOT MISSING(Peak_mins_ratio_out) then do;
if Peak_mins_ratio_out < 0.93 then do;
GRP_Peak_mins_ratio_out = 2;
end;
else
if 0.93 <= Peak_mins_ratio_out AND Peak_mins_ratio_out < 1.07 then do;
GRP_Peak_mins_ratio_out = 3;
end;
else
if 1.07 <= Peak_mins_ratio_out AND Peak_mins_ratio_out < 1.22 then do;
GRP_Peak_mins_ratio_out = 4;
end;
else
if 1.22 <= Peak_mins_ratio_out then do;
GRP_Peak_mins_ratio_out = 5;
end;
end;

*------------------------------------------------------------*;
* Variable: mon_dif;
*------------------------------------------------------------*;
LABEL GRP_mon_dif = 'Grouped: mon_dif';

if MISSING(mon_dif) then do;
GRP_mon_dif = 1;
end;
else if NOT MISSING(mon_dif) then do;
if mon_dif < 93 then do;
GRP_mon_dif = 2;
end;
else
if 93 <= mon_dif AND mon_dif < 106 then do;
GRP_mon_dif = 3;
end;
else
if 106 <= mon_dif AND mon_dif < 118 then do;
GRP_mon_dif = 4;
end;
else
if 118 <= mon_dif then do;
GRP_mon_dif = 5;
end;
end;

*------------------------------------------------------------*;
* Variable: tariff;
*------------------------------------------------------------*;
LABEL GRP_tariff = 'Grouped: tariff';

_UFormat = put(tariff,$CHAR8.0);
%dmnormip(_UFormat);
if MISSING(_UFORMAT) then do;
GRP_tariff = 1;
end;
else if NOT MISSING(_UFORMAT) then do;
if (_UFORMAT eq 'CAT 200'
) then do;
GRP_tariff = 2;
end;
else
if (_UFORMAT eq 'CAT 100'
) then do;
GRP_tariff = 3;
end;
else
if (_UFORMAT eq 'PLAY 100'
) then do;
GRP_tariff = 4;
end;
else
if (_UFORMAT eq 'PLAY 300'
) then do;
GRP_tariff = 5;
end;
else
if (_UFORMAT eq 'CAT 50'
) then do;
GRP_tariff = 6;
end;
else do;
GRP_tariff = 1;
end;
end;
*------------------------------------------------------------*;
* TOOL: Drop Node;
* TYPE: MODIFY;
* NODE: Drop2;
*------------------------------------------------------------*;
*------------------------------------------------------------*;
* TOOL: Regression;
* TYPE: MODEL;
* NODE: Reg;
*------------------------------------------------------------*;
*************************************;
*** begin scoring code for regression;
*************************************;

length _WARN_ $4;
label _WARN_ = 'Warnings' ;

length I_Churn2 $ 1;
label I_Churn2 = 'Into: Churn2' ;
*** Target Values;
array REGDRF [2] $1 _temporary_ ('1' '0' );
label U_Churn2 = 'Unnormalized Into: Churn2' ;
format U_Churn2 BEST1.;
*** Unnormalized target values;
ARRAY REGDRU[2]  _TEMPORARY_ (1 0);

drop _DM_BAD;
_DM_BAD=0;

*** Generate dummy variables for GRP_IMP_Age ;
drop _1_0 _1_1 _1_2 ;
if missing( GRP_IMP_Age ) then do;
   _1_0 = .;
   _1_1 = .;
   _1_2 = .;
   substr(_warn_,1,1) = 'M';
   _DM_BAD = 1;
end;
else do;
   length _dm12 $ 12; drop _dm12 ;
   _dm12 = put( GRP_IMP_Age , BEST12. );
   %DMNORMIP( _dm12 )
   if _dm12 = '5'  then do;
      _1_0 = -1;
      _1_1 = -1;
      _1_2 = -1;
   end;
   else if _dm12 = '4'  then do;
      _1_0 = 0;
      _1_1 = 0;
      _1_2 = 1;
   end;
   else if _dm12 = '3'  then do;
      _1_0 = 0;
      _1_1 = 1;
      _1_2 = 0;
   end;
   else if _dm12 = '2'  then do;
      _1_0 = 1;
      _1_1 = 0;
      _1_2 = 0;
   end;
   else do;
      _1_0 = .;
      _1_1 = .;
      _1_2 = .;
      substr(_warn_,2,1) = 'U';
      _DM_BAD = 1;
   end;
end;

*** Generate dummy variables for GRP_OffPeak_calls_ratio ;
drop _2_0 _2_1 _2_2 ;
if missing( GRP_OffPeak_calls_ratio ) then do;
   _2_0 = .;
   _2_1 = .;
   _2_2 = .;
   substr(_warn_,1,1) = 'M';
   _DM_BAD = 1;
end;
else do;
   length _dm12 $ 12; drop _dm12 ;
   _dm12 = put( GRP_OffPeak_calls_ratio , BEST12. );
   %DMNORMIP( _dm12 )
   if _dm12 = '5'  then do;
      _2_0 = -1;
      _2_1 = -1;
      _2_2 = -1;
   end;
   else if _dm12 = '2'  then do;
      _2_0 = 1;
      _2_1 = 0;
      _2_2 = 0;
   end;
   else if _dm12 = '3'  then do;
      _2_0 = 0;
      _2_1 = 1;
      _2_2 = 0;
   end;
   else if _dm12 = '4'  then do;
      _2_0 = 0;
      _2_1 = 0;
      _2_2 = 1;
   end;
   else do;
      _2_0 = .;
      _2_1 = .;
      _2_2 = .;
      substr(_warn_,2,1) = 'U';
      _DM_BAD = 1;
   end;
end;

*** Generate dummy variables for GRP_OffPeak_mins_ratio ;
drop _4_0 _4_1 _4_2 ;
if missing( GRP_OffPeak_mins_ratio ) then do;
   _4_0 = .;
   _4_1 = .;
   _4_2 = .;
   substr(_warn_,1,1) = 'M';
   _DM_BAD = 1;
end;
else do;
   length _dm12 $ 12; drop _dm12 ;
   _dm12 = put( GRP_OffPeak_mins_ratio , BEST12. );
   %DMNORMIP( _dm12 )
   if _dm12 = '3'  then do;
      _4_0 = 0;
      _4_1 = 1;
      _4_2 = 0;
   end;
   else if _dm12 = '4'  then do;
      _4_0 = 0;
      _4_1 = 0;
      _4_2 = 1;
   end;
   else if _dm12 = '5'  then do;
      _4_0 = -1;
      _4_1 = -1;
      _4_2 = -1;
   end;
   else if _dm12 = '2'  then do;
      _4_0 = 1;
      _4_1 = 0;
      _4_2 = 0;
   end;
   else do;
      _4_0 = .;
      _4_1 = .;
      _4_2 = .;
      substr(_warn_,2,1) = 'U';
      _DM_BAD = 1;
   end;
end;

*** Generate dummy variables for GRP_Peak_calls_1234 ;
drop _6_0 _6_1 _6_2 ;
if missing( GRP_Peak_calls_1234 ) then do;
   _6_0 = .;
   _6_1 = .;
   _6_2 = .;
   substr(_warn_,1,1) = 'M';
   _DM_BAD = 1;
end;
else do;
   length _dm12 $ 12; drop _dm12 ;
   _dm12 = put( GRP_Peak_calls_1234 , BEST12. );
   %DMNORMIP( _dm12 )
   if _dm12 = '4'  then do;
      _6_0 = 0;
      _6_1 = 0;
      _6_2 = 1;
   end;
   else if _dm12 = '5'  then do;
      _6_0 = -1;
      _6_1 = -1;
      _6_2 = -1;
   end;
   else if _dm12 = '3'  then do;
      _6_0 = 0;
      _6_1 = 1;
      _6_2 = 0;
   end;
   else if _dm12 = '2'  then do;
      _6_0 = 1;
      _6_1 = 0;
      _6_2 = 0;
   end;
   else do;
      _6_0 = .;
      _6_1 = .;
      _6_2 = .;
      substr(_warn_,2,1) = 'U';
      _DM_BAD = 1;
   end;
end;

*** Generate dummy variables for GRP_Peak_calls_56 ;
drop _7_0 _7_1 _7_2 ;
if missing( GRP_Peak_calls_56 ) then do;
   _7_0 = .;
   _7_1 = .;
   _7_2 = .;
   substr(_warn_,1,1) = 'M';
   _DM_BAD = 1;
end;
else do;
   length _dm12 $ 12; drop _dm12 ;
   _dm12 = put( GRP_Peak_calls_56 , BEST12. );
   %DMNORMIP( _dm12 )
   if _dm12 = '3'  then do;
      _7_0 = 0;
      _7_1 = 1;
      _7_2 = 0;
   end;
   else if _dm12 = '4'  then do;
      _7_0 = 0;
      _7_1 = 0;
      _7_2 = 1;
   end;
   else if _dm12 = '5'  then do;
      _7_0 = -1;
      _7_1 = -1;
      _7_2 = -1;
   end;
   else if _dm12 = '2'  then do;
      _7_0 = 1;
      _7_1 = 0;
      _7_2 = 0;
   end;
   else do;
      _7_0 = .;
      _7_1 = .;
      _7_2 = .;
      substr(_warn_,2,1) = 'U';
      _DM_BAD = 1;
   end;
end;

*** Generate dummy variables for GRP_Peak_mins_ratio ;
drop _8_0 _8_1 _8_2 ;
if missing( GRP_Peak_mins_ratio ) then do;
   _8_0 = .;
   _8_1 = .;
   _8_2 = .;
   substr(_warn_,1,1) = 'M';
   _DM_BAD = 1;
end;
else do;
   length _dm12 $ 12; drop _dm12 ;
   _dm12 = put( GRP_Peak_mins_ratio , BEST12. );
   %DMNORMIP( _dm12 )
   if _dm12 = '5'  then do;
      _8_0 = -1;
      _8_1 = -1;
      _8_2 = -1;
   end;
   else if _dm12 = '3'  then do;
      _8_0 = 0;
      _8_1 = 1;
      _8_2 = 0;
   end;
   else if _dm12 = '2'  then do;
      _8_0 = 1;
      _8_1 = 0;
      _8_2 = 0;
   end;
   else if _dm12 = '4'  then do;
      _8_0 = 0;
      _8_1 = 0;
      _8_2 = 1;
   end;
   else do;
      _8_0 = .;
      _8_1 = .;
      _8_2 = .;
      substr(_warn_,2,1) = 'U';
      _DM_BAD = 1;
   end;
end;

*** Generate dummy variables for GRP_mon_dif ;
drop _10_0 _10_1 _10_2 ;
if missing( GRP_mon_dif ) then do;
   _10_0 = .;
   _10_1 = .;
   _10_2 = .;
   substr(_warn_,1,1) = 'M';
   _DM_BAD = 1;
end;
else do;
   length _dm12 $ 12; drop _dm12 ;
   _dm12 = put( GRP_mon_dif , BEST12. );
   %DMNORMIP( _dm12 )
   if _dm12 = '5'  then do;
      _10_0 = -1;
      _10_1 = -1;
      _10_2 = -1;
   end;
   else if _dm12 = '3'  then do;
      _10_0 = 0;
      _10_1 = 1;
      _10_2 = 0;
   end;
   else if _dm12 = '4'  then do;
      _10_0 = 0;
      _10_1 = 0;
      _10_2 = 1;
   end;
   else if _dm12 = '2'  then do;
      _10_0 = 1;
      _10_1 = 0;
      _10_2 = 0;
   end;
   else do;
      _10_0 = .;
      _10_1 = .;
      _10_2 = .;
      substr(_warn_,2,1) = 'U';
      _DM_BAD = 1;
   end;
end;

*** Generate dummy variables for GRP_tariff ;
drop _11_0 _11_1 _11_2 _11_3 ;
*** encoding is sparse, initialize to zero;
_11_0 = 0;
_11_1 = 0;
_11_2 = 0;
_11_3 = 0;
if missing( GRP_tariff ) then do;
   _11_0 = .;
   _11_1 = .;
   _11_2 = .;
   _11_3 = .;
   substr(_warn_,1,1) = 'M';
   _DM_BAD = 1;
end;
else do;
   length _dm12 $ 12; drop _dm12 ;
   _dm12 = put( GRP_tariff , BEST12. );
   %DMNORMIP( _dm12 )
   _dm_find = 0; drop _dm_find;
   if _dm12 <= '4'  then do;
      if _dm12 <= '3'  then do;
         if _dm12 = '2'  then do;
            _11_0 = 1;
            _dm_find = 1;
         end;
         else do;
            if _dm12 = '3'  then do;
               _11_1 = 1;
               _dm_find = 1;
            end;
         end;
      end;
      else do;
         if _dm12 = '4'  then do;
            _11_2 = 1;
            _dm_find = 1;
         end;
      end;
   end;
   else do;
      if _dm12 = '5'  then do;
         _11_3 = 1;
         _dm_find = 1;
      end;
      else do;
         if _dm12 = '6'  then do;
            _11_0 = -1;
            _11_1 = -1;
            _11_2 = -1;
            _11_3 = -1;
            _dm_find = 1;
         end;
      end;
   end;
   if not _dm_find then do;
      _11_0 = .;
      _11_1 = .;
      _11_2 = .;
      _11_3 = .;
      substr(_warn_,2,1) = 'U';
      _DM_BAD = 1;
   end;
end;

*** If missing inputs, use averages;
if _DM_BAD > 0 then do;
   _P0 = 0.0586894254;
   _P1 = 0.9413105746;
   goto REGDR1;
end;

*** Compute Linear Predictor;
drop _TEMP;
drop _LP0;
_LP0 = 0;

***  Effect: GRP_IMP_Age ;
_TEMP = 1;
_LP0 = _LP0 + (    0.69830426411196) * _TEMP * _1_0;
_LP0 = _LP0 + (   -0.08106789047937) * _TEMP * _1_1;
_LP0 = _LP0 + (   -0.53204396790518) * _TEMP * _1_2;

***  Effect: GRP_OffPeak_calls_ratio ;
_TEMP = 1;
_LP0 = _LP0 + (    0.23139470538011) * _TEMP * _2_0;
_LP0 = _LP0 + (    0.17507240183427) * _TEMP * _2_1;
_LP0 = _LP0 + (   -0.09234979420177) * _TEMP * _2_2;

***  Effect: GRP_OffPeak_mins_ratio ;
_TEMP = 1;
_LP0 = _LP0 + (    0.21606904694734) * _TEMP * _4_0;
_LP0 = _LP0 + (   -0.16912920629492) * _TEMP * _4_1;
_LP0 = _LP0 + (   -0.41929885075073) * _TEMP * _4_2;

***  Effect: GRP_Peak_calls_1234 ;
_TEMP = 1;
_LP0 = _LP0 + (    0.43197178694663) * _TEMP * _6_0;
_LP0 = _LP0 + (    0.18166110900745) * _TEMP * _6_1;
_LP0 = _LP0 + (   -0.03929226424369) * _TEMP * _6_2;

***  Effect: GRP_Peak_calls_56 ;
_TEMP = 1;
_LP0 = _LP0 + (    0.08573939140872) * _TEMP * _7_0;
_LP0 = _LP0 + (    0.18984247641494) * _TEMP * _7_1;
_LP0 = _LP0 + (    0.06492535975522) * _TEMP * _7_2;

***  Effect: GRP_Peak_mins_ratio ;
_TEMP = 1;
_LP0 = _LP0 + (    0.20441011140502) * _TEMP * _8_0;
_LP0 = _LP0 + (    0.10631819862474) * _TEMP * _8_1;
_LP0 = _LP0 + (    0.33836183607967) * _TEMP * _8_2;

***  Effect: GRP_mon_dif ;
_TEMP = 1;
_LP0 = _LP0 + (    0.64639070261728) * _TEMP * _10_0;
_LP0 = _LP0 + (    0.16877942353213) * _TEMP * _10_1;
_LP0 = _LP0 + (   -0.28893340808593) * _TEMP * _10_2;

***  Effect: GRP_tariff ;
_TEMP = 1;
_LP0 = _LP0 + (   -0.11481831904295) * _TEMP * _11_0;
_LP0 = _LP0 + (    0.22861504888289) * _TEMP * _11_1;
_LP0 = _LP0 + (    0.16245836826518) * _TEMP * _11_2;
_LP0 = _LP0 + (   -0.15819706757075) * _TEMP * _11_3;

*** Naive Posterior Probabilities;
drop _MAXP _IY _P0 _P1;
_TEMP =    -3.11841524244499 + _LP0;
if (_TEMP < 0) then do;
   _TEMP = exp(_TEMP);
   _P0 = _TEMP / (1 + _TEMP);
end;
else _P0 = 1 / (1 + exp(-_TEMP));
_P1 = 1.0 - _P0;

REGDR1:


*** Posterior Probabilities and Predicted Level;
label P_Churn21 = 'Predicted: Churn2=1' ;
label P_Churn20 = 'Predicted: Churn2=0' ;
P_Churn21 = _P0;
_MAXP = _P0;
_IY = 1;
P_Churn20 = _P1;
if (_P1 - _MAXP > 1e-8) then do;
   _MAXP = _P1;
   _IY = 2;
end;
I_Churn2 = REGDRF[_IY];
U_Churn2 = REGDRU[_IY];

*************************************;
***** end scoring code for regression;
*************************************;
*------------------------------------------------------------*;
* TOOL: Model Compare Class;
* TYPE: ASSESS;
* NODE: MdlComp;
*------------------------------------------------------------*;
if (P_Churn21 ge 0.16599187736709) then do;
b_Churn2 = 1;
end;
else
if (P_Churn21 ge 0.13051641484714) then do;
b_Churn2 = 2;
end;
else
if (P_Churn21 ge 0.10436520725255) then do;
b_Churn2 = 3;
end;
else
if (P_Churn21 ge 0.0903133847738) then do;
b_Churn2 = 4;
end;
else
if (P_Churn21 ge 0.07719002607951) then do;
b_Churn2 = 5;
end;
else
if (P_Churn21 ge 0.06735276655219) then do;
b_Churn2 = 6;
end;
else
if (P_Churn21 ge 0.05961670604522) then do;
b_Churn2 = 7;
end;
else
if (P_Churn21 ge 0.05140376826126) then do;
b_Churn2 = 8;
end;
else
if (P_Churn21 ge 0.04710219984931) then do;
b_Churn2 = 9;
end;
else
if (P_Churn21 ge 0.0414858066697) then do;
b_Churn2 = 10;
end;
else
if (P_Churn21 ge 0.03637391144405) then do;
b_Churn2 = 11;
end;
else
if (P_Churn21 ge 0.03206328178855) then do;
b_Churn2 = 12;
end;
else
if (P_Churn21 ge 0.02861532723754) then do;
b_Churn2 = 13;
end;
else
if (P_Churn21 ge 0.02405660427064) then do;
b_Churn2 = 14;
end;
else
if (P_Churn21 ge 0.02055760497982) then do;
b_Churn2 = 15;
end;
else
if (P_Churn21 ge 0.018122426979) then do;
b_Churn2 = 16;
end;
else
if (P_Churn21 ge 0.01453379329892) then do;
b_Churn2 = 17;
end;
else
if (P_Churn21 ge 0.01134293159247) then do;
b_Churn2 = 18;
end;
else
if (P_Churn21 ge 0.00753654082009) then do;
b_Churn2 = 19;
end;
else
do;
b_Churn2 = 20;
end;
*------------------------------------------------------------*;
* TOOL: Score Node;
* TYPE: ASSESS;
* NODE: Score;
*------------------------------------------------------------*;
*------------------------------------------------------------*;
* Score: Creating Fixed Names;
*------------------------------------------------------------*;
LABEL EM_SEGMENT = 'Segment';
EM_SEGMENT = b_Churn2;
LABEL EM_EVENTPROBABILITY = 'Probability for level 1 of Churn2';
EM_EVENTPROBABILITY = P_Churn21;
LABEL EM_PROBABILITY = 'Probability of Classification';
EM_PROBABILITY = max(
P_Churn21
,
P_Churn20
);
LENGTH EM_CLASSIFICATION $%dmnorlen;
LABEL EM_CLASSIFICATION = "Prediction for Churn2";
EM_CLASSIFICATION = I_Churn2;
