
/*-------------------------------
 *-----Lemorzsolds elemzs-----
 *---------Soltsz Gbor---------
 *----------2010.11.22.----------
 *-------------------------------
 */

/*Munkaknyvtr definilsa*/
libname telco 'd:\telco\data\';

/*Csatlakozs dtuma s a mai nap kztt eltelt hnapok szma*/
data telco.custinform2;
 set telco.custinform;
 tday=today();
 mon_dif = intck('month',Connect_Date,tday);
run;

/*Eloszlsvizsglat*/
proc univariate data=telco.custinform2;
 var mon_dif;
 histogram mon_dif;
run;

/*1. 2. 3. 4. hnap adatai aggreglva*/
proc sql;
create table telco.cdr_1234 as
select customer_id, sum(Peak_calls) as Peak_calls_1234, sum(peak_mins) as peak_mins_1234, sum(OffPeak_calls) as OffPeak_calls_1234, sum(OffPeak_mins) as OffPeak_mins_1234, sum(Weekend_calls) as Weekend_calls_1234, sum(Weekend_mins) as Weekend_mins_1234, sum(International_mins) as International_mins_1234
from telco.cdr
where month='month1' or month='month2' or month='month3' or month='month4'
group by customer_id
order by customer_id;
quit;

/*5. 6. hnap adatai aggreglva*/
proc sql;
create table telco.cdr_56 as
select customer_id, sum(Peak_calls) as Peak_calls_56, sum(peak_mins) as peak_mins_56, sum(OffPeak_calls) as OffPeak_calls_56, sum(OffPeak_mins) as OffPeak_mins_56, sum(Weekend_calls) as Weekend_calls_56, sum(Weekend_mins) as Weekend_mins_56, sum(International_mins) as International_mins_56
from telco.cdr
where month='month5' or month='month6'
group by customer_id
order by customer_id;
quit;

/*A kt tbla sszeillesztse s lekrdezse*/
proc sql;
select a.*, b.* from
telco.cdr_1234 as a
inner join
telco.cdr_56 as b
on a.customer_id = b.customer_id;
quit;

/*A kt tbla sszeillesztse egy tblba*/
proc sql;
create table telco.cdr_agg as
select a.*, b.* from
telco.cdr_1234 as a
inner join
telco.cdr_56 as b
on a.customer_id = b.customer_id;
quit;

/*A szrzodskts dtuma s a mai nap kztt a hnapok szma*/
data telco.custinform2;
 set telco.custinform;
 tday=today();
 mon_dif = intck('month',Connect_Date,tday);
run;

/*Eloszls*/
proc univariate data=telco.custinform2;
 var mon_dif;
 histogram mon_dif;
run;

/*Fiatalts 40 hnappal*/
data telco.custinform2;
 set telco.custinform;
 tday=today();
 mon_dif = (intck('month',Connect_Date,tday)-40);
run;
/*Eloszls*/
proc univariate data=telco.custinform2;
 var mon_dif;
 histogram mon_dif;
run;

data telco.cdr_mod;
 set telco.cdr_agg;
 /*Egy hvs tlagos idotartama az 1.2.3.4. hnapokban*/
 if Peak_calls_1234=0 then Peak_dur_1234=0;
 else Peak_dur_1234=Peak_mins_1234 / Peak_calls_1234;

 if OffPeak_calls_1234=0 then OffPeak_dur_1234=0;
 else OffPeak_dur_1234=OffPeak_mins_1234 / OffPeak_calls_1234;

 if Weekend_calls_1234=0 then Weekend_dur_1234=0;
 else Weekend_dur_1234=Weekend_mins_1234 / Weekend_calls_1234;
 /*Egy hvs tlagos idotartama az 5.6. hnapokban*/
 if Peak_calls_56=0 then Peak_dur_56=0;
 else Peak_dur_56=Peak_mins_56 / Peak_calls_56;

 if OffPeak_calls_56=0 then OffPeak_dur_56=0;
 else OffPeak_dur_56=OffPeak_mins_56 / OffPeak_calls_56;

 if Weekend_calls_56=0 then Weekend_dur_56=0;
 else Weekend_dur_56=Weekend_mins_56 / Weekend_calls_56;
run;

data telco.cdr_mod;
 set telco.cdr_mod;
 /*Kategorizls az 1.2.3.4. hnapok adataira*/
 if 	 Peak_dur_1234 lt 0.5 then Peak_dur_1234_cat='1: <0.5';
 else if Peak_dur_1234 lt 1   then Peak_dur_1234_cat='2: <1';
 else if Peak_dur_1234 lt 2   then Peak_dur_1234_cat='2: <2';
 else if Peak_dur_1234 lt 5   then Peak_dur_1234_cat='2: <5';
 else if Peak_dur_1234 ge 5   then Peak_dur_1234_cat='2: >=5';

 if 	 OffPeak_dur_1234 lt 0.5 then OffPeak_dur_1234_cat='1: <0.5';
 else if OffPeak_dur_1234 lt 1   then OffPeak_dur_1234_cat='2: <1';
 else if OffPeak_dur_1234 lt 2   then OffPeak_dur_1234_cat='2: <2';
 else if OffPeak_dur_1234 lt 5   then OffPeak_dur_1234_cat='2: <5';
 else if OffPeak_dur_1234 ge 5   then OffPeak_dur_1234_cat='2: >=5';

 if 	 Weekend_dur_1234 lt 0.5 then Weekend_dur_1234_cat='1: <0.5';
 else if Weekend_dur_1234 lt 1   then Weekend_dur_1234_cat='2: <1';
 else if Weekend_dur_1234 lt 2   then Weekend_dur_1234_cat='2: <2';
 else if Weekend_dur_1234 lt 5   then Weekend_dur_1234_cat='2: <5';
 else if Weekend_dur_1234 ge 5   then Weekend_dur_1234_cat='2: >=5';
 /*Kategorizlsaz 5.6. hnapokban*/
 if 	 Peak_dur_56 lt 0.5 then Peak_dur_56_cat='1: <0.5';
 else if Peak_dur_56 lt 1   then Peak_dur_56_cat='2: <1';
 else if Peak_dur_56 lt 2   then Peak_dur_56_cat='2: <2';
 else if Peak_dur_56 lt 5   then Peak_dur_56_cat='2: <5';
 else if Peak_dur_56 ge 5   then Peak_dur_56_cat='2: >=5';

 if 	 OffPeak_dur_56 lt 0.5 then OffPeak_dur_56_cat='1: <0.5';
 else if OffPeak_dur_56 lt 1   then OffPeak_dur_56_cat='2: <1';
 else if OffPeak_dur_56 lt 2   then OffPeak_dur_56_cat='2: <2';
 else if OffPeak_dur_56 lt 5   then OffPeak_dur_56_cat='2: <5';
 else if OffPeak_dur_56 ge 5   then OffPeak_dur_56_cat='2: >=5';

 if 	 Weekend_dur_56 lt 0.5 then Weekend_dur_56_cat='1: <0.5';
 else if Weekend_dur_56 lt 1   then Weekend_dur_56_cat='2: <1';
 else if Weekend_dur_56 lt 2   then Weekend_dur_56_cat='2: <2';
 else if Weekend_dur_56 lt 5   then Weekend_dur_56_cat='2: <5';
 else if Weekend_dur_56 ge 5   then Weekend_dur_56_cat='2: >=5';

 /*Arnyszmts a hvsok szmra*/
 if Peak_calls_1234=0 then Peak_calls_ratio=0;
 else Peak_calls_ratio = (Peak_calls_56 / 2) / (Peak_calls_1234 / 4);

 if OffPeak_calls_1234=0 then OffPeak_calls_ratio=0;
 else OffPeak_calls_ratio = (OffPeak_calls_56 / 2) / (OffPeak_calls_1234 / 4);

 if Weekend_calls_1234=0 then Weekend_calls_ratio=0;
 else Weekend_calls_ratio = (Weekend_calls_56 / 2) / (Weekend_calls_1234 / 4);

 /*Arnyszmts a hvsok idotartamra*/
 if Peak_mins_1234=0 then Peak_mins_ratio=0;
 else Peak_mins_ratio = (Peak_mins_56 / 2) / (Peak_mins_1234 / 4);

 if OffPeak_mins_1234=0 then OffPeak_mins_ratio=0;
 else OffPeak_mins_ratio = (OffPeak_mins_56 / 2) / (OffPeak_mins_1234 / 4);

 if Weekend_mins_1234=0 then Weekend_mins_ratio=0;
 else Weekend_mins_ratio = (Weekend_mins_56 / 2) / (Weekend_mins_1234 / 4);

 /*Arnyszmts a hvsok tlagos idotartamra*/
 if Peak_dur_1234=0 then Peak_dur_ratio=0;
 else Peak_dur_ratio = (Peak_dur_56 / 2) / (Peak_dur_1234 / 4);

 if OffPeak_dur_1234=0 then OffPeak_dur_ratio=0;
 else OffPeak_dur_ratio = (OffPeak_dur_56 / 2) / (OffPeak_dur_1234 / 4);

 if Weekend_dur_1234=0 then Weekend_dur_ratio=0;
 else Weekend_dur_ratio = (Weekend_dur_56 / 2) / (Weekend_dur_1234 / 4);
run;

/*Ler statisztika*/
proc means data=telco.cdr_mod mean stderr maxdec=4;
output out=telco.stat;
run;

/*Szlsortkek szurse
 *tlag + 3*standard hiba  
 */
data telco.cdr_mod_out;
 set telco.cdr_mod;
/*tlagos idotartam korriglsa 1.2.3.4. hnapra*/

 if      Peak_dur_1234 gt (7.2482+(3*22.376)) then Peak_dur_1234_out = (7.2482+(3*22.376));
 else if Peak_dur_1234 lt (7.2482-(3*22.376)) then Peak_dur_1234_out = (7.2482-(3*22.376));
 else    Peak_dur_1234_out = Peak_dur_1234;

 if      OffPeak_dur_1234 gt (5.9843 + (3 * 12.975)) then OffPeak_dur_1234_out = (5.9843 + (3 * 12.975));
 else if OffPeak_dur_1234 lt (5.9843 - (3 * 12.975)) then OffPeak_dur_1234_out = (5.9843 - (3 * 12.975));
 else    OffPeak_dur_1234_out = OffPeak_dur_1234;


 if      Weekend_dur_1234 gt (3.278 + (3 * 4.8716)) then Weekend_dur_1234_out = (3.278 + (3 * 4.8716));
 else if Weekend_dur_1234 lt (3.278 - (3 * 4.8716)) then Weekend_dur_1234_out = (3.278 - (3 * 4.8716));
 else    Weekend_dur_1234_out = Weekend_dur_1234;

 /*tlagos idotartam korriglsa 5.6. hnapra*/
 if      Peak_dur_56 gt (8.6774 + (3 * 38.1303)) then Peak_dur_56_out = (8.6774 + (3 * 38.1303));
 else if Peak_dur_56 lt (8.6774 - (3 * 38.1303)) then Peak_dur_56_out = (8.6774 - (3 * 38.1303));
 else    Peak_dur_56_out = Peak_dur_56;

 if      OffPeak_dur_56 gt (7.9258 + (3 * 25.29)) then OffPeak_dur_56_out = (7.9258 + (3 * 25.29));
 else if OffPeak_dur_56 lt (7.9258 - (3 * 25.29)) then OffPeak_dur_56_out = (7.9258 - (3 * 25.29));
 else    OffPeak_dur_56_out = OffPeak_dur_56;

 if      Weekend_dur_56 gt (5.216 + (3 * 9.6019)) then Weekend_dur_56_out = (5.216 + (3 * 9.6019));
 else if Weekend_dur_56 lt (5.216 - (3 * 9.6019)) then Weekend_dur_56_out = (5.216 - (3 * 9.6019));
 else    Weekend_dur_56_out = Weekend_dur_56;

 /*Arny korriglsa*/

 if      Peak_calls_ratio gt (1.143 + (3 * 0.3972)) then Peak_calls_ratio_out = (1.143 + (3 * 0.3972));
 else if Peak_calls_ratio lt (1.143 - (3 * 0.3972)) then Peak_calls_ratio_out = (1.143 - (3 * 0.3972));
 else    Peak_calls_ratio_out = Peak_calls_ratio;

 if      OffPeak_calls_ratio gt (1.166 + (3 * 0.528)) then OffPeak_calls_ratio_out = (1.166 + (3 * 0.528));
 else if OffPeak_calls_ratio lt (1.166 - (3 * 0.528)) then OffPeak_calls_ratio_out = (1.166 - (3 * 0.528));
 else OffPeak_calls_ratio_out = OffPeak_calls_ratio;

 if      Weekend_calls_ratio gt (1.1293 + (3 * 0.9956)) then Weekend_calls_ratio_out = (1.1293 + (3 * 0.9956));
 else if Weekend_calls_ratio lt (1.1293 - (3 * 0.9956)) then Weekend_calls_ratio_out = (1.1293 - (3 * 0.9956));
 else    Weekend_calls_ratio_out = Weekend_calls_ratio;

 if      Peak_mins_ratio gt (1.0618 + (3 * 0.2685)) then Peak_mins_ratio_out = (1.0618 + (3 * 0.2685));
 else if Peak_mins_ratio lt (1.0618 - (3 * 0.2685)) then Peak_mins_ratio_out = (1.0618 - (3 * 0.2685));
 else    Peak_mins_ratio_out = Peak_mins_ratio;

 if      OffPeak_mins_ratio gt (1.0291 + (3 * 0.3210)) then OffPeak_mins_ratio_out = (1.0291 + (3 * 0.3210));
 else if OffPeak_mins_ratio lt (1.0291 - (3 * 0.3210)) then OffPeak_mins_ratio_out = (1.0291 - (3 * 0.3210));
 else    OffPeak_mins_ratio_out = OffPeak_mins_ratio;

 if      Weekend_mins_ratio gt (0.7913 + (3 * 0.5142)) then Weekend_mins_ratio_out = (0.7913 + (3 * 0.5142));
 else if Weekend_mins_ratio lt (0.7913 - (3 * 0.5142)) then Weekend_mins_ratio_out = (0.7913 - (3 * 0.5142));
 else    Weekend_mins_ratio_out = Weekend_mins_ratio;

 /*tlagos idotartam arnya korriglva*/

 if      Peak_dur_ratio gt (1.857 + (3 * 0.3611)) then Peak_dur_ratio_out = (1.857 + (3 * 0.3611));
 else if Peak_dur_ratio lt (1.857 - (3 * 0.3611)) then Peak_dur_ratio_out = (1.857 - (3 * 0.3611));
 else    Peak_dur_ratio_out = Peak_dur_ratio;

 if      OffPeak_dur_ratio gt (1.7553 + (3 * 0.5021)) then OffPeak_dur_ratio_out = (1.7553 + (3 * 0.5021));
 else if OffPeak_dur_ratio lt (1.7553 - (3 * 0.5021)) then OffPeak_dur_ratio_out = (1.7553 - (3 * 0.5021));
 else    OffPeak_dur_ratio_out = OffPeak_dur_ratio;

 if      Weekend_dur_ratio gt (1.237 + (3 * 0.8576)) then Weekend_dur_ratio_out = (1.237 + (3 * 0.8576));
 else if Weekend_dur_ratio lt (1.237 - (3 * 0.8576)) then Weekend_dur_ratio_out = (1.237 - (3 * 0.8576));
 else    Weekend_dur_ratio_out = Weekend_dur_ratio;
run;

/*-----------------------------------
 *------------KIAGSZTS------------
 *--------Adathiny generls--------
 *-----------------------------------
 */
 data telco.custinform2;
  set telco.custinform2;
   random=ranuni(1);
   if random le 0.2 then age=.;
 run;

/*-----------------------------------
 *---------------SCORE---------------
 *-----------------------------------
 */

/*Validl minta generls*/
data telco.cdr_valid;
 set telco.cdr;
 retain obs 0;
 obs=obs+1;
run;

/*4000 vletlen megfigyelsszm generls*/
data telco.cdr_part;
 do i=0 to 4000;
 obs=int(19610*ranuni(1)+1);
 output;
 i=i+1;
 end;
run;

proc sql;
create table telco.valid_data as
select a.*, b.* from
telco.cdr_valid as a
inner join
telco.cdr_part as b
on a.obs=b.obs;
quit;

proc sql;
create table telco.score_data as
select a.*, b.* from
telco.custinform2 as a
inner join
telco.valid_data as b
on a.Customer_ID=b.Customer_ID;
quit;

/*VGE*/
